/*
 Modified by Cameron Skinner
 May 2005: Converted to librescue
*/

#ifndef MISC_SIMULATOR_H
#define MISC_SIMULATOR_H

#include "config.h"
#include "objectpool.h"
#include "objects.h"
#include "MISC.hxx"
#include "misc_property.h"
#include "AutoPtr.hxx"
#include "misc_parameter.h"

namespace Rescue
{
     typedef std::vector<Humanoid*> MCivils;
	 typedef std::map<INT_32,AutoPtr<MiscProperty> > Properties;

     /** ֥Ȥν */
     class MiscSimulator
     {
     private:
	  ObjectPool& m_pool;
	  const Config* cfg;
	  MiscParameter prmt;
	  Dice dice;
	  Properties properties;

     protected:
//////////////////////////////////////////////////////////////////////////
///////  MiscSimulator Ǥɲ
//////////////////////////////////////////////////////////////////////////
	  MCivils m_agent;
	  MCivils m_death;             // ˴
	  MCivils m_injury;           // 
	  MCivils m_treatedInRefuge;; // ǼŤ줿 Civilian

	  MCivils m_inCivils[ATTB_MAX+1][SEISMIC_MAX+1];       // : ¤ͼ, 
	  MCivils m_inCivilsBroken[ATTB_MAX+1][SEISMIC_MAX+1]; // ݲȲ: ¤ͼ, 
	  MCivils m_inCivilsFiery[ATTB_MAX+1][SEISMIC_MAX+1];  // ƲȲ: ¤ͼ, 

	  MCivils m_victimBroken[ATTB_MAX+1][SEISMIC_MAX+1][BROKEN_MAX+1]; // ݲȲ: ¤ͼ, , ݲ
	  MCivils m_indoor[ATTB_MAX];
	  MCivils m_inBuildingFiery; // ǳƤʪˤ

	  Objects m_buildingBroken; // ݲηʪ
	  Objects m_buildingFiery;  // ηʪ

	  MCivils m_onRoadBlock; // ĺɤȤƻϩˤ륨

     public:
	  virtual ~MiscSimulator();
	  MiscSimulator(ObjectPool& objects, const Config& config, INT_32 seed);	     
	  MiscSimulator();

	  // ΥƥåפΥߥ졼ʹ
	  void step(INT_32 time);

	  void classifyObjects(INT_32 time);

	  void classifyBuilding(INT_32 time, Building* b);

	  // Ȥʬ
	  void classifyAgents(INT_32 time, Humanoid* h);
	  void classifyCivils(INT_32 time, Humanoid* mc);

	  //////////////////////////////////////////////////////////////
	  // Ԥ (Ȳ¤, ٤ˤ)
	  void setBuried(INT_32 time);
	  void setBuried(INT_32 time, AttBuilding ABuild, GradeSeismic SGrade);

	  //////////////////////////////////////////////////////////////
	  // ᡼ (Ƹˤ)
	  void setDamages(INT_32 time);

	  //////////////////////////////////////////////////////////////
	  // Ȳݲˤ᡼
	  void setDamageBroken(INT_32 time);

	  //////////////////////////////////////////////////////////////
	  // ȲкҤˤ᡼
	  void setDamageFiery(INT_32 time);

	  //////////////////////////////////////////////////////////////
	  // TODO: ϩǤμϤβȲкҤˤ᡼
	  void setDamageFieryRoad(INT_32 time);

	  //////////////////////////////////////////////////////////////
	  // ƻϩĺɤˤ᡼
	  void setDamageBlock(INT_32 time);

	  //////////////////////////////////////////////////////////////
	  // Civilian ʳΥȤΥ᡼Ψ򤫤
	  INT_32 magnificationDamageBroken(INT_32 time, Humanoid* h, INT_32 damage);
	  INT_32 magnificationDamageFiery(INT_32 time, Humanoid* h, INT_32 damage);
	  INT_32 magnificationDamageBlock(INT_32 time, Humanoid* h, INT_32 damage);

	  //////////////////////////////////////////////////////////////
	  // ƻϩĺɤˤ᡼
	  void mergeDamages(INT_32 time, Humanoid* mc);

	  //////////////////////////////////////////////////////////////
	  // ᡼οʹ
	  void progressDamages(INT_32 time);
	  void progressDamages(INT_32 time, Humanoid* mc);
	  void progressDamageBury(INT_32 time, Humanoid* mc);
	  void progressDamageBroken(INT_32 time, Humanoid* mc);
	  void progressDamageFiery(INT_32 time, Humanoid* mc);
	  void progressDamageBlock(INT_32 time, Humanoid* mc);

	  //////////////////////////////////////////////////////////////
	  // Hp ι
	  void updateHp(INT_32 time, Humanoid* mc);

	  //////////////////////////////////////////////////////////////
	  // ᡼μ
	  //       damage  0 ˤ
	  void treatDamage(INT_32, Humanoid* mc);

     private:
	  MiscSimulator(const MiscSimulator& source);
	  MiscSimulator& operator= (const MiscSimulator& rhs);
	  bool operator== (const MiscSimulator& rhs) const;
// by TM
	  void MiscSimulator::mysrand(Humanoid* h, INT_32 time) { srand(cfg->misc_random_seed() * h->id() * time); }
     };

     /////////////////////////////////////////////////////////////////////////
} // namespace Rescue

#endif // } !defined(MISCOBJECTPOOL_HXX__INCLUDED)
